/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2011, Tomasz Sowa
 * All rights reserved.
 * 
 */

#ifndef headerfile_winix_plugins_export_exportinfo
#define headerfile_winix_plugins_export_exportinfo

#include "core/system.h"
#include "export.h"
#include "db.h"
#include "message.h"
#include "exportthread.h"



namespace Export
{


class ExportInfo
{
public:

	ExportInfo();

	void SetSystem(System * psystem);
	void SetConfig(Config * pconfig);
	void SetDb(Db * pdb);
	void SetExportThread(ExportThread * pexport_thread);

	void ReadExportDirs();
	void ReadConfigVars();

	ExportDir * FindDir(long dir_id);

	bool DecodePass(Export & exp);

	void SendFile(const Item & item, bool thumb = false);
	void SendDir(const Item & item);
	void SendDir(long dir_id);

private:

	System * system;
	Config * config;
	Db * db;
	ExportThread * export_thread;

	bool use_rsa;
	std::wstring rsa_key;
	std::string pass_decrypted;
	Message msg;
	Export exp;
	std::wstring tmp_dir;
	std::vector<ExportDir> export_dirs;

	bool SkipDir(long dir_id, std::wstring & dir);

};

}

#endif

